import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { MerchantAccount, MerchantAccountParam } from './model';
import { SERVER_API_URL } from '@/config/setting';

/**
 * 分页查询商户账号
 */
export async function pageMerchantAccount(params: MerchantAccountParam) {
  const res = await request.get<ApiResult<PageResult<MerchantAccount>>>(
    SERVER_API_URL + '/system/merchant-account/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商户账号列表
 */
export async function listMerchantAccount(params?: MerchantAccountParam) {
  const res = await request.get<ApiResult<MerchantAccount[]>>(
    SERVER_API_URL + '/system/merchant-account',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商户账号
 */
export async function addMerchantAccount(data: MerchantAccount) {
  const res = await request.post<ApiResult<unknown>>(
    SERVER_API_URL + '/system/merchant-account',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商户账号
 */
export async function updateMerchantAccount(data: MerchantAccount) {
  const res = await request.put<ApiResult<unknown>>(
    SERVER_API_URL + '/system/merchant-account',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商户账号
 */
export async function removeMerchantAccount(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    SERVER_API_URL + '/system/merchant-account/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商户账号
 */
export async function removeBatchMerchantAccount(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    SERVER_API_URL + '/system/merchant-account/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商户账号
 */
export async function getMerchantAccount(id: number) {
  const res = await request.get<ApiResult<MerchantAccount>>(
    SERVER_API_URL + '/system/merchant-account/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

export async function getMerchantAccountByPhone(params?: MerchantAccountParam) {
  const res = await request.get<ApiResult<MerchantAccount>>(
    SERVER_API_URL + '/system/merchant-account/getMerchantAccountByPhone',
    {
      params
    }
  );
  if (res.data.code === 1) {
    return null;
  }
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
